import calendar
calendar.setfirstweekday(6) #start day  Mon(0)-Sun(6)
from DateTime import DateTime

def catalog_getevents(self, year, month):
    """ given a year and month return a list of days that have events """
    first_date=DateTime(str(month)+'/1/'+str(year))
    last_day=calendar.monthrange(year, month)[1]
    last_date=DateTime(str(month)+'/'+str(last_day)+'/'+str(year))

    query=self.portal_catalog(Type='Event',
                              start=(first_date, last_date),
                              start_usage='range:min:max',
                              sort_on='start')
    # I don't like doing two searches
    # What i want to do is
    # start date => 1/1/2002 and start date <= 31/1/2002
    # or
    # end date => 1/1/2002 and end date <= 31/1/2002
    # but I don't know how to do that in one search query :(  - AD
    query+=self.portal_catalog(Type='Event',
                               end=(first_date, last_date),
                               end_usage='range:min:max',
                               sort_on='end')
    
    # compile a list of the days that have events
    eventDays=[]
    for result in query:
        eventStartDay = result.start.day()
        eventStartMonth = result.start.month()
        eventEndDay = result.end.day()
        eventEndMonth = result.end.month()
        # we need to deal with events that end next month
        if eventEndMonth > month:
            eventEndDay = last_day
        # and events that started last month
        if eventStartMonth < month:
            eventStartDay = 1
        allEventDays = range(eventStartDay, eventEndDay+1)
        eventDays.extend(allEventDays)
        # This list is not uniqued and isn't sorted
        # uniquing and sorting only wastes time
        # and in this example we don't need to because
        # later we are going to do an 'if 2 in eventDays'
        # so the order is not important.
        # example:  [23, 28, 29, 30, 31, 23]
    return eventDays

def getEventsForCalendar(self, month='1', year='2002'):
    """ recreates a sequence of weeks, by days each day is a mapping.
        {'day': #, 'url': None}
    """
    year=int(year)
    month=int(month)
    # daysByWeek is a list of days inside a list of weeks, like so:
    # [[0, 1, 2, 3, 4, 5, 6],
    #  [7, 8, 9, 10, 11, 12, 13],
    #  [14, 15, 16, 17, 18, 19, 20],
    #  [21, 22, 23, 24, 25, 26, 27],
    #  [28, 29, 30, 31, 0, 0, 0]]
    daysByWeek=calendar.monthcalendar(year, month)
    weeks=[]
    
    events=catalog_getevents(self, year, month)

    for week in daysByWeek:
        days=[]
        for day in week:
            if day==0:day=''
            day = { 'day' : day, 'event' : day in events }
            days.append(day)

        weeks.append(days)
        
    return weeks
